/**
 * Test for apeman-ui-contrib-angular-arraying.
 * Runs with karma.
 */

"use strict";

var mock = angular.mock;

describe('apeman-ui-contrib-angular-arraying', function () {

    var apArray;

    beforeEach(mock.module('apeman-ui-contrib-angular-arraying'));

    beforeEach(mock.inject(function (_apArray_) {
        apArray = _apArray_;
    }));

    describe('apArray', function () {
        it('Contains or not.', function () {
            var array = ['foo', 'bar'];
            expect(apArray.contains(array, 'foo')).toEqual(true);
            expect(apArray.contains(array, 'baz')).toEqual(false);
        });

        it('Create unique array.', function () {
            var array = apArray.unique(['foo', 'bar', 'foo']);
            expect(array).toEqual(['foo', 'bar']);
        });

        it('Map property value.', function () {
            var array = [{name: 'foo'}, {name: 'bar'}];
            expect(apArray.mapPropertyValue(array, 'name')).toEqual(['foo', 'bar']);
        });

        it('Reject by property value.', function () {
            var array = [{name: 'foo'}, {name: 'bar'}];
            expect(apArray.rejectByPropertyValue(array, 'name', 'bar')).toEqual([{name: 'foo'}]);
        });
    });
});